local uc = select(2, UnitClass("player"))
if (uc ~= "HUNTER") and (uc ~= "ROGUE") then return end


MisDirectionHelperLDB = LibStub("AceAddon-3.0"):NewAddon("MisDirectionHelperLDB", "AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("MisDirectionHelper",true)
local QTC = LibStub("LibQTip-1.0")
local icon = LibStub("LibDBIcon-1.0")
local _G = _G
local addon = MisDirectionHelperLDB
local MDHText = "MDH"
local channels = {["RAID"] = _G.RAID, ["PARTY"] = _G.PARTY, ["WHISPER"] = _G.WHISPER}
local misdtarget, tooltip

local function set(info, value)

	local key = info[#info]
	addon.db.profile[key] = value

end

local function get(info)

	local key = info[#info]
	return addon.db.profile[key]

end

local defaults = {
	profile = {
		LibDBIcon = { hide = false },
		cChannel = "PARTY",
		Name = "",
		Petname = _G.UNKNOWN,
		bAnnounce = false,
	},	
}
   
local optionsTable = {
	handler = addon,
	type = "group",
	desc = "MisDirectionHelper",
	inline = false,
	args = {
		basicDesc = {
			order = 1,
			type = "description",
			name = _G.MAIN_MENU,
		},
		showMinimapIcon = {
			order = 2,
			type = "toggle",
			name = L["Minimap Icon"],
			desc = L["Toggle Minimap icon"],
			get = function(info) return not addon.db.profile.LibDBIcon.hide end,
			set = function(info, value)
				addon.db.profile.LibDBIcon.hide = not value
				if value then
					icon:Show("MisDirectionHelper")
				else
					icon:Hide("MisDirectionHelper")
				end
			end,
		},
		buffmessage = {
			order = 3,
			type = "toggle",
			name = L["Buff Alert"],
			desc = L["Toggle Misdirection Applied Announcment"],
			get = function(info) return addon.db.profile.bAnnounce end,
			set = function(info, value)
				addon.db.profile.bAnnounce = value
			end,
		},
		cChannel = {
		  type = "select",
		  name = L["Buff Channel"],
		  desc = L["Select Channel for Buff Announcements"],
		  order = 4,
		  get = function(info) return addon.db.profile.cChannel end,
		  set = function(info, value)
				  addon.db.profile.cChannel = value
			   end,
		  values = channels,
		},
	},
}

--Create the data broker
MisDirectionHelperLDB.dataObject = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("MisDirectionHelper", {
	type = "data source",
	text = MDHText,
	icon = "Interface\\Icons\\Ability_Hunter_Misdirection",
	OnClick = 
		function(frame, button)
			if button == "RightButton" then
				InterfaceOptionsFrame_OpenToCategory(addon.optionsFrame)
			elseif button == "LeftButton" then
				addon:PlyrTarg()
			end
		end,
	OnEnter = 
		function(frame)
			tooltip = QTC:Acquire("Broker_MisDirectionHelperTooltip", 1, "CENTER")
			tooltip:SmartAnchorTo(frame)
			tooltip:SetAutoHideDelay(0.25, frame)
			addon:mdhShowToolTip()
		end,
	OnLeave = nil,
})

local function HandlerFunc(arg)

    if arg == "b1" then

		addon:PrtyTank()

    elseif arg == "b2" then
	
		addon:PlyrTarg()

    elseif arg == "b3" then

		addon:ToT()

	elseif arg == "b4" then

		addon:PlyrPet()

	elseif arg == "b5" then

		addon:PopUp()

	elseif arg == "b6" then

		InterfaceOptionsFrame_OpenToCategory(addon.optionsFrame)

    end

end

function addon:mdhShowToolTip()

	local headerFont, y
	
    tooltip:Clear()
    
	headerFont = CreateFont("MisDirectionHelperHeaderFont")
	MisDirectionHelperHeaderFont:CopyFontObject(GameTooltipHeaderText)
	MisDirectionHelperHeaderFont:SetFont(MisDirectionHelperHeaderFont:GetFont(), 15)
	
    y = tooltip:AddLine()
	tooltip:SetCell(y, 1, "|cffffff00MisDirectionHelper|r",MisDirectionHelperHeaderFont, "CENTER", 1)
    tooltip:SetLineColor(1, 1, 0, 1, 1)
	
    y = tooltip:AddLine()
	tooltip:SetCell(y, 1, "", "CENTER", 1)
	tooltip:SetLineColor(2, 0, 0, 1, 1)
	
	y = tooltip:AddLine()
	tooltip:SetCell(y, 1, "", "CENTER", 1)
    tooltip:SetLineColor(3, 0, 0, 1, 1)

    y = tooltip:AddLine()
	tooltip:SetCell(y, 1, " " .. L["Set To Party Tank"])
	tooltip:SetCellScript(y, 1, "OnMouseDown", function() HandlerFunc("b1") end)
    tooltip:SetLineColor(4, 1, 0, 0, 1)
	
    y = tooltip:AddLine()
    tooltip:SetCell(y, 1, " " .. L["Set To Target"])
	tooltip:SetCellScript(y, 1, "OnMouseDown", function() HandlerFunc("b2") end)
    tooltip:SetLineColor(5, 1, 0, 0, 1)
	
    y = tooltip:AddLine()
    tooltip:SetCell(y, 1, " " .. L["Set to Target Of Target"])
	tooltip:SetCellScript(y, 1, "OnMouseDown", function() HandlerFunc("b3") end)
    tooltip:SetLineColor(6, 1, 0, 0, 1)

    y = tooltip:AddLine()
	tooltip:SetCell(y, 1, "", "CENTER", 1)
	tooltip:SetLineColor(7, 0, 0, 1, 1)
	
	if uc == "HUNTER" then
	
		y = tooltip:AddLine()
		tooltip:SetCell(y, 1, " " .. L["Set to Your Pet"])
		tooltip:SetCellScript(y, 1, "OnMouseDown", function() HandlerFunc("b4") end)
		tooltip:SetLineColor(8, 0, 1, 1, 1)
		
	end

    y = tooltip:AddLine()
    tooltip:SetCell(y, 1, " " .. L["Enter Player Name"])
	tooltip:SetCellScript(y, 1, "OnMouseDown", function() HandlerFunc("b5") end)
	tooltip:SetLineColor(9, 0, 1, 1, 1)
	
	y = tooltip:AddLine()
	tooltip:SetCell(y, 1, "", "CENTER", 1)
	tooltip:SetLineColor(10, 0, 0, 1, 1)
	
	y = tooltip:AddLine()
	tooltip:SetCell(y, 1, "", "CENTER", 1)
	tooltip:SetLineColor(11, 0, 0, 1, 1)
	
	y = tooltip:AddLine()
    tooltip:SetCell(y, 1, _G.OPTIONS, "b6")
    tooltip:SetLineColor(12, 0, 1, 0, 1)
	
    y = tooltip:AddLine()
	tooltip:SetCell(y, 1, "", "CENTER", 1)
	tooltip:SetLineColor(13, 0, 0, 1, 1)
	 
	y = tooltip:AddLine()
	tooltip:SetCell(y, 1, "", "CENTER", 1)
	tooltip:SetLineColor(14, 0, 0, 1, 1)
	
	y = tooltip:AddLine()
	tooltip:SetCell(y, 1, "|cffffff00" .. string.format(L["MDH is set to: %s"], "|cffff0033 " .. self:TTText()), "CENTER", 1)
	tooltip:SetLineColor(15, 1, 0, 1, 0)
	
    y = tooltip:AddLine()
	tooltip:SetCell(y, 1, "", "CENTER", 1)
	tooltip:SetLineColor(16, 0, 0, 1, 1)
	
	y = tooltip:AddLine()
	tooltip:SetCell(y, 1, "", "CENTER", 1)
	tooltip:SetLineColor(17, 0, 0, 1, 1)
	
	y = tooltip:AddLine()
	tooltip:SetCell(y, 1, "|cffffff00" .. L["Left Click Each Text To Activate"] .. "|r ", "CENTER", 1)
	tooltip:SetLineColor(18, 1, 0, 1, 1)
	
	y = tooltip:AddLine()
	tooltip:SetCell(y, 1, "|cffffff00" .. L["Right Click For MDH Options"] .. "|r", "CENTER", 1)
    tooltip:SetLineColor(19, 1, 0, 1, 1)
	
    if (InCombatLockdown()) then return end
	
    tooltip:Show()

end

function addon:MDHTextUpdate()

	 if self.db.profile.Name == "" then

		MisDirectionHelperLDB.dataObject.text = (MDHText)

	 else
	 
		MisDirectionHelperLDB.dataObject.text = self.db.profile.Name
		
	 end

end

function addon:PlyrTarg()

	self:MDHtarget()
	self:MDHEditMacro()
	self:mdhShowToolTip()
	
end

function addon:ToT()

	self.db.profile.Name = "targettarget"
	self:MDHEditMacro()
	self:mdhShowToolTip()
	
end

function addon:PlyrPet()

	if UnitExists("pet") then
	
		self:MDHgetpet()

	end
	
	self.db.profile.Name = self.db.profile.Petname
	self:MDHEditMacro()
	self:mdhShowToolTip()
	
end

function addon:PrtyTank()

	self:MDHtank()
	self:MDHEditMacro()
	self:mdhShowToolTip()
	
end

function addon:PopUp()

	StaticPopup_Show("MDH_GET_PLAYER_NAME")

end

function addon:MDHLoad()

	if UnitExists("pet") then

		self:MDHgetpet()
		
	end

	self:MDHTextUpdate()

end

function addon:MDHgetpet()

	local petname = UnitName("pet")

	if petname == _G.UNKNOWN then
	
		petname = self.db.profile.Petname
		
	end

	self.db.profile.Petname = petname

end

function addon:MDHtarget()

	if UnitExists("target") then
	
		self.db.profile.Name = UnitName("target")
		
	end
	
end

function addon:MDHtank()

	local NumParty=GetNumPartyMembers()
	local NumRaid=GetNumRaidMembers()
	local mdhealth = 0
	local mdtank = self.db.profile.Name
	local i, class

	if (0 < NumParty) and (NumRaid == 0) then

		for i = 1, NumParty do
		
			_, class = UnitClass("party" .. i)
			
			if ("WARRIOR" == class) or ("DRUID" == class) or ("DEATHKNIGHT" == class) or ("PALADIN" == class) then

				if mdhealth < UnitHealth("party" .. i) then
				
					mdhealth = UnitHealth("party" .. i)
					mdtank = UnitName("party" .. i)

				end
				
			end	
			
		end
		
	elseif 0 < NumRaid then
	
		for i = 1, NumRaid do
		
			_, class=UnitClass("raid" .. i)
			
			if ("WARRIOR" == class) or ("DRUID" == class) or ("DEATHKNIGHT" == class) or ("PALADIN" == class) then
			
				if mdhealth < UnitHealth("raid" .. i) then
				
					mdhealth = UnitHealth("raid" .. i)
					mdtank = UnitName("raid" .. i)
					
				end
				
			end	
			
		end
		
	end
	
	self.db.profile.Name = mdtank

end

function addon:MDHEditMacro()

	local macro, macroid
	local spell = L["Misdirection"]
	
	if uc == "ROGUE" then
	
		spell = L["Tricks of the Trade"]
		
	end
	
	self:MDHTextUpdate()

	if self.db.profile.Name == "targettarget" then

		macro = string.format("#showtooltip %s\n/cast [target=targettarget,exists] %s;%s", spell, spell, spell)

	else
	
		macro = string.format("#showtooltip %s\n/cast [target=%s,exists] %s; %s", spell, self.db.profile.Name, spell, spell)
		
	end

	macroid = GetMacroIndexByName(spell)

	if macroid == 0 then
	
		CreateMacro(spell , 134, macro, 1, 1)

	else

		EditMacro(macroid, spell , 134, macro)

	end

end

function addon:MDHChat()

	local msg = string.format((uc == "HUNTER") and L["%s Misdirects to %s"] or L["%s casts Tricks of the Trade on %s"], UnitName("player"), misdtarget)
	local s = false
	
	if IsAddOnLoaded("CastYeller2") or IsAddOnLoaded("CastYeller") then return end

	if (self.db.profile.cChannel == "PARTY") and (GetNumPartyMembers() ~= 0) then
	
		s = true

	elseif (self.db.profile.cChannel == "RAID") and (GetNumRaidMembers() ~= 0) then

		s = true
		
	elseif (addon.db.profile.cChannel == "WHISPER") then
	
		s = true

	end
	
	if s then SendChatMessage(msg, self.db.profile.cChannel, nil, misdtarget) end

end

function addon:OnInitialize()
	
	self.db = LibStub("AceDB-3.0"):New("MisDirectionHelperDB", defaults)
	optionsTable.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	LibStub("AceConfig-3.0"):RegisterOptionsTable("MisDirectionHelper", optionsTable)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("MisDirectionHelper", "MisDirectionHelper")
	 
	if icon then

		icon:Register("MisDirectionHelper", MisDirectionHelperLDB.dataObject, self.db.profile.LibDBIcon)
		
	end
	
	self:MDHOnload()

end

function addon:MDHOnload()

	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:RegisterEvent("UNIT_PET")
	self:RegisterEvent("UNIT_SPELLCAST_SENT")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")

end

function addon:PLAYER_ENTERING_WORLD()

	self:MDHLoad()

end

function addon:UNIT_PET(unitid)

	if unitid == "player" and UnitExists("pet") then
  
		self:MDHgetpet()

	end

end

function addon:UNIT_SPELLCAST_SENT(unitid, spell, rank, target)

	if (unitid == "player") and (spell == GetSpellInfo(34477)) then
	
		misdtarget = target

	end

end

function addon:UNIT_SPELLCAST_SUCCEEDED(unitid, spell, rank, uk, spellid)

	if (unitid == "player") and (spell == GetSpellInfo(34477)) then
	
		if self.db.profile.bAnnounce then

			self:MDHChat()

		end
		
	end
	
end

function addon:TTText()

	if self.db.profile.Name == "" then

		return L["Nobody"]

	else

		return self.db.profile.Name

  end
 
end

local function onAccept(this)

	if not UnitAffectingCombat("player") then
	
		addon.db.profile.Name = this.editBox:GetText() .. " "
		
		if (addon.db.profile.Name == "Pet") or (addon.db.profile.Name == "pet") then
		
			addon.db.profile.Name = addon.db.profile.Petname
			
		elseif (addon.db.profile.Name == "Tank") or (addon.db.profile.Name == "tank") then
		
			addon:MHDtank()
			
		elseif (addon.db.profile.Name == "Target") or (addon.db.profile.Name == "target") or (addon.db.profile.Name == "t")then
		
			addon:MHDtarget()
			
		end
		
		addon:MDHEditMacro()
		
	end

	addon:mdhShowToolTip()

end

StaticPopupDialogs["MDH_GET_PLAYER_NAME"] = {
	text = (uc == "HUNTER") and L["Player to Misdirect to"] or L["Player to cast Tricks of the Trade on"],
	button1 = _G.ACCEPT,
	button2 = _G.CANCEL,
	hasEditBox = 1,
	OnAccept = onAccept,
	EditBoxOnEnterPressed = function(this) onAccept(this:GetParent()); this:GetParent():Hide() end,
	EditBoxOnEscapePressed = function(this) this:GetParent():Hide()	end,
	timeout = 0,
	whileDead = 1,
	hideOnEscape = 1
}